package actions

import (
	"github.com/gin-gonic/gin"
    "github.com/iapologizewhenimwrong/Vestmore_GO/utils/basic"
    "github.com/iapologizewhenimwrong/Vestmore_GO/utils/log"
)

var HandlersFuncRoutes map[string]gin.HandlerFunc = make(map[string]gin.HandlerFunc)

func init() {
{{- range .}}
    // func {{.FuncName}}(ctx *gin.Context, param *{{.ParamStruct.ParamStructName}}, resp *basic.Response)
	HandlersFuncRoutes["{{.ActionName}}"] = {{.FuncName}}Handler
{{- end}}
}

{{- range .}}
type {{.ParamStruct.ParamStructName}} struct {
	{{- range .ParamStruct.ParamFields}}
	{{.ParamNameCamel}} {{.ParamType}} `json:"{{.ParamName}}" form:"{{.ParamName}}" binding:"{{.ParamBinding}}"`
	{{- end}}
}

func {{.FuncName}}Handler(ctx *gin.Context) {
    resp := &basic.Response{IsSuccess: true}
	defer ctx.JSON(200, resp)

	param := &{{.ParamStruct.ParamStructName}}{}
	err := ctx.ShouldBind(param)
	if err != nil {
        log.Println(err)
		resp.Error(basic.ErrParamParse)
		return
	}
 
    {{.FuncName}}(ctx, param, resp)
}
{{end}}